searchNodes=[{"doc":"SDK to facilitate Elixir integrations with the Stark Bank API. Submodules: StarkBank.Auth: Used to manage credentials and login; StarkBank.Charge: Used to create and consult charges;","ref":"StarkBank.html","title":"StarkBank","type":"module"},{"doc":"Used to manage credentials and to create a new session (login) with the StarkBank API Functions: login update_access_token insert_external_access_token logout get_env get_workspace get_email get_access_token get_member_id get_workspace_id get_name get_permissions get_auto_refresh","ref":"StarkBank.Auth.html","title":"StarkBank.Auth","type":"module"},{"doc":"Gets the access_token saved in the credentials agent after login Parameters: credentials [PID]: credentials returned by Auth.login Returns: access_token [string] Examples iex&gt; StarkBank.Auth.get_access_token(credentials) &quot;507837650305024057114529712046081608a18e96724397ad149ab182785568cddee9381a714acc903d9e0a5d17ef71&quot;","ref":"StarkBank.Auth.html#get_access_token/1","title":"StarkBank.Auth.get_access_token/1","type":"function"},{"doc":"Gets the auto_refresh setting saved in the credentials agent after login Parameters: credentials: credentials returned by Auth.login [PID] Returns: auto_refresh [boolean] Examples iex&gt; StarkBank.Auth.get_permissions(credentials) [&quot;admin&quot;]","ref":"StarkBank.Auth.html#get_auto_refresh/1","title":"StarkBank.Auth.get_auto_refresh/1","type":"function"},{"doc":"Gets the email saved in the credentials agent Parameters: credentials [PID]: credentials returned by Auth.login Returns: email [string] Examples iex&gt; StarkBank.Auth.get_email(credentials) &quot;user@email.com&quot;","ref":"StarkBank.Auth.html#get_email/1","title":"StarkBank.Auth.get_email/1","type":"function"},{"doc":"Gets the environment saved in the credentials agent Parameters: credentials [PID]: credentials returned by Auth.login Returns: environment [:sandbox or :production] Examples iex&gt; StarkBank.Auth.get_env(credentials) :sandbox","ref":"StarkBank.Auth.html#get_env/1","title":"StarkBank.Auth.get_env/1","type":"function"},{"doc":"Gets the member_id saved in the credentials agent after login Parameters: credentials [PID]: credentials returned by Auth.login Returns: password [string] Examples iex&gt; StarkBank.Auth.get_member_id(credentials) &quot;5711452971204608&quot;","ref":"StarkBank.Auth.html#get_member_id/1","title":"StarkBank.Auth.get_member_id/1","type":"function"},{"doc":"Gets the member name saved in the credentials agent after login Parameters: credentials [PID]: credentials returned by Auth.login Returns: name [string] Examples iex&gt; StarkBank.Auth.get_name(credentials) &quot;Arya Stark&quot;","ref":"StarkBank.Auth.html#get_name/1","title":"StarkBank.Auth.get_name/1","type":"function"},{"doc":"Gets the user permissions saved in the credentials agent after login Parameters: credentials [PID]: credentials returned by Auth.login Returns: permissions [list of string] Examples iex&gt; StarkBank.Auth.get_permissions(credentials) [&quot;admin&quot;]","ref":"StarkBank.Auth.html#get_permissions/1","title":"StarkBank.Auth.get_permissions/1","type":"function"},{"doc":"Gets the workspace saved in the credentials agent Parameters: credentials [PID]: credentials returned by Auth.login Returns: workspace [string] Examples iex&gt; StarkBank.Auth.get_workspace(credentials) &quot;workspace&quot;","ref":"StarkBank.Auth.html#get_workspace/1","title":"StarkBank.Auth.get_workspace/1","type":"function"},{"doc":"Gets the workspace_id saved in the credentials agent after login Parameters: credentials [PID]: credentials returned by Auth.login Returns: workspace_id [string] Examples iex&gt; StarkBank.Auth.get_workspace_id(credentials) &quot;5078376503050240&quot; &quot;&quot;","ref":"StarkBank.Auth.html#get_workspace_id/1","title":"StarkBank.Auth.get_workspace_id/1","type":"function"},{"doc":"Inserts an external access-token into the current credentials agent. This is used mostly along with {auto_refresh: false} when managing multiple workers that are using the same session. Parameters: credentials [PID]: credentials returned by Auth.login access_token [string]: access_token that should be used by this worker Examples iex&gt; StarkBank.Auth.update_access_token(credentials, &quot;50783765030502405711452971204608ac4d4a86e5934c858afb3e493bd3424457566319ae5244629854d36e76649f13&quot;)","ref":"StarkBank.Auth.html#insert_external_access_token/2","title":"StarkBank.Auth.insert_external_access_token/2","type":"function"},{"doc":"Creates a new access-token and invalidates all others Parameters: env [atom]: :sandbox, :production workspace [string]: workspace name email [string]: email password [string]: password options [keyword list]: refines request access_token [string, default nil]: if nil, a new access_token will be requested from the API, else, it will be saved for further use without making any requests auto_refresh [bool, default true]: if true, any credentials errors returned by the API will be responded with one attempt to retrieve a new access_token and remake the request; Returns {:ok, credentials}: credentials: PID of agent that holds the credentials information, including the access-token. This PID must be passed as parameter to all SDK calls Examples iex&gt; StarkBank.Auth.login(:sandbox, &quot;workspace&quot;, &quot;user@email.com&quot;, &quot;password&quot;) {:ok, #PID&lt;0.178.0&gt;}","ref":"StarkBank.Auth.html#login/5","title":"StarkBank.Auth.login/5","type":"function"},{"doc":"Deletes current session and invalidates current access-token Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; Returns: parsed API response json Examples iex&gt; StarkBank.Auth.logout(credentials) {:ok, %{&quot;message&quot; =&gt; &quot;Your session has been successfully closed&quot;}}","ref":"StarkBank.Auth.html#logout/1","title":"StarkBank.Auth.logout/1","type":"function"},{"doc":"Recicles the access-token present in the credentials agent Parameters: credentials [PID]: credentials returned by Auth.login Returns {:ok, credentials}: credentials: PID of agent that holds the credentials information, including the access-token. This PID must be passed as parameter to all SDK calls Examples iex&gt; StarkBank.Auth.update_access_token(credentials) {:ok, #PID&lt;0.190.0&gt;}","ref":"StarkBank.Auth.html#update_access_token/1","title":"StarkBank.Auth.update_access_token/1","type":"function"},{"doc":"Used to create and consult charges Submodules: StarkBank.Charge.Customer: Used to create and consult charge customers; StarkBank.Charge.Log: Used to consult charge logs; Functions: post get delete get_pdf","ref":"StarkBank.Charge.html","title":"StarkBank.Charge","type":"module"},{"doc":"Deletes the specified charges Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; charges [list of strings or StarkBank.Charge.Structs.ChargeData]: charge IDs or data structs to be deleted, e.g.: [&quot;5718322100305920&quot;, &quot;5705293853884416&quot;]; Returns {:ok, deleted_charges}: deleted_charges [list of StarkBank.Charge.Structs.ChargeData]: deleted charges; Example: iex&gt; StarkBank.Charge.delete(credentials, [&quot;1872563178531872&quot;, charge_2, &quot;1092381029381092&quot;, charge_4])","ref":"StarkBank.Charge.html#delete/2","title":"StarkBank.Charge.delete/2","type":"function"},{"doc":"Gets charges according to the provided parameters Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; options [keyword list]: refines request status [string]: filters specified charge status, namely: &quot;created&quot;, &quot;registered&quot;, &quot;paid&quot;, &quot;overdue&quot;, &quot;canceled&quot; or &quot;failed&quot;; tags [list of strings]: filters charges by tags, e.g.: [&quot;client1&quot;, &quot;cash-in&quot;]; ids [list of strings or StarkBank.Charge.Structs.ChargeData]: charge IDs or data structs to be retrieved, e.g.: [&quot;5718322100305920&quot;, &quot;5705293853884416&quot;]; fields [list of strings]: selects charge data fields on API response, e.g.: [&quot;id&quot;, &quot;amount&quot;, &quot;status&quot;]; filter_after [date or string (&quot;%Y-%m-%d&quot;)]: only gets charges created after this date, e.g.: &quot;2019-04-01&quot;; filter_before [date or string (&quot;%Y-%m-%d&quot;)]: only gets charges created before this date, e.g.: &quot;2019-05-01&quot;; limit [int]: maximum results retrieved; Returns {:ok, retrieved_charges}: retrieved_charges [list of StarkBank.Charge.Structs.ChargeData]: retrieved charges; Example: iex&gt; StarkBank.Charge.get(credentials, tags: [&quot;test&quot;, &quot;stark&quot;], filter_after: Date.add(Date.utc_today(), -7))","ref":"StarkBank.Charge.html#get/2","title":"StarkBank.Charge.get/2","type":"function"},{"doc":"Gets the specified charge PDF file content Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; charge [string or StarkBank.Charge.Structs.ChargeData]: charge ID or data struct, e.g.: &quot;5718322100305920&quot;; Returns {:ok, pdf_content}: pdf_content [string]: pdf file content; Example: iex&gt; StarkBank.Charge.get_pdf(credentials, &quot;1872563178531872&quot;) iex&gt; StarkBank.Charge.get_pdf(credentials, charge)","ref":"StarkBank.Charge.html#get_pdf/2","title":"StarkBank.Charge.get_pdf/2","type":"function"},{"doc":"Creates new charges. For each charge customer that is specified without an ID, the SDK will first get customers by its tax_id and, if no customers are a full match or if the &#39;overwrite_customer_on_mismatch&#39; is false (default), a new customer will be created and associated with the charge. If &#39;overwrite_customer_on_mismatch&#39; is true, the first retrieved customer will be overwritten with the provided customer data. Therefore, providing ID-less customers may slow the function down significantly, due to the possibly great number of subcalls to the API. Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; charges [list of StarkBank.Charge.Structs.ChargeData]: charge structs; options [keyword list]: refines request overwrite_customer_on_mismatch [bool, default false]: if true, first mismatching customer will be overwritten, if any; if false, new customer will be created (only active if no matching customers are located) discount [int]: defines discount in cents if charge is paid before discountDate (if discount is defined, discountDate must also be defined) discount_date [date or string (&quot;%Y-%m-%d&quot;)]: defines up to when the defined discount will be valid (if discount is defined, discountDate must also be defined) Returns {:ok, posted_charges}: posted_charges [list of StarkBank.Charge.Structs.ChargeData]: posted charges; Example: iex&gt; StarkBank.Charge.post(credentials, [charge_1, charge_2])","ref":"StarkBank.Charge.html#post/3","title":"StarkBank.Charge.post/3","type":"function"},{"doc":"Used to create, update and delete charge customers Functions: post get get_by_id delete put","ref":"StarkBank.Charge.Customer.html","title":"StarkBank.Charge.Customer","type":"module"},{"doc":"Deletes the specified charge customers Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; customers [list of strings or list of StarkBank.Charge.Structs.CustomerData (with valid IDs)]: charge customer data or IDs, e.g.: [&quot;6307371336859648&quot;]; Returns {:ok, deleted_customers}: deleted_customers [list of StarkBank.Charge.Structs.CustomerData]: deleted customers; Example: iex&gt; StarkBank.Charge.Customer.delete(credentials, [&quot;6307371336859648&quot;, &quot;5087311326867881&quot;])","ref":"StarkBank.Charge.Customer.html#delete/2","title":"StarkBank.Charge.Customer.delete/2","type":"function"},{"doc":"Gets charge customers data according to informed parameters Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; options [keyword list]: refines request fields [list of strings]: list of customer fields that should be retrieved from the API; tags [list of strings]: filters customers by the provided tags; tax_id [string]: filters customers by tax ID; limit [int]: maximum results retrieved; Returns {:ok, retrieved_customers}: retrieved_customers [list of StarkBank.Charge.Structs.CustomerData]: lists all retrieved customers; Example: iex&gt; StarkBank.Charge.Customer.get(credentials, fields: [&quot;tax_id&quot;, &quot;name&quot;], limit: 30)","ref":"StarkBank.Charge.Customer.html#get/2","title":"StarkBank.Charge.Customer.get/2","type":"function"},{"doc":"Gets the charge customer with the specified ID Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; customer [string or StarkBank.Charge.Structs.CustomerData (with valid ID)]: charge customer ID, e.g.: &quot;6307371336859648&quot;; Returns {:ok, retrieved_customer}: retrieved_customer [StarkBank.Charge.Structs.CustomerData]: retrieved customer; Example: iex&gt; StarkBank.Charge.Customer.get_by_id(credentials, &quot;6307371336859648&quot;) iex&gt; StarkBank.Charge.Customer.get_by_id(credentials, customer_1)","ref":"StarkBank.Charge.Customer.html#get_by_id/2","title":"StarkBank.Charge.Customer.get_by_id/2","type":"function"},{"doc":"Registers new customers that can be linked with charge emissions Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; customers: list of StarkBank.Charge.Structs.CustomerData; Returns {:ok, posted_customers}: posted_customers [list of StarkBank.Charge.Structs.CustomerData]: lists all posted customers; Example: iex&gt; StarkBank.Charge.Customer.post(credentials, [customer_1, customer_2])","ref":"StarkBank.Charge.Customer.html#post/2","title":"StarkBank.Charge.Customer.post/2","type":"function"},{"doc":"Overwrites the charge customer with the specified ID Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; customer [StarkBank.Charge.Structs.CustomerData]: charge customer data; Returns {:ok, overwritten_customer}: overwritten_customer [StarkBank.Charge.Structs.CustomerData]: overwritten customer; Example: iex&gt; StarkBank.Charge.Customer.put(credentials, customer_1)","ref":"StarkBank.Charge.Customer.html#put/2","title":"StarkBank.Charge.Customer.put/2","type":"function"},{"doc":"Used to consult charge events; Functions: get get_by_id","ref":"StarkBank.Charge.Log.html","title":"StarkBank.Charge.Log","type":"module"},{"doc":"Gets the charge logs according to the provided parameters Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; charge_ids [list of strings or list of StarkBank.Charge.Structs.ChargeData]: charge IDs or charge structs, e.g.: [&quot;5618308887871488&quot;]; options [keyword list]: refines request events [list of string]: filter by log events, namely: &quot;register&quot;, &quot;registered&quot;, &quot;overdue&quot;, &quot;updated&quot;, &quot;canceled&quot;, &quot;failed&quot;, &quot;paid&quot; or &quot;bank&quot;; limit [int]: maximum results retrieved; Returns {:ok, charge_logs}: charge_logs [list of StarkBank.Charge.Structs.ChargeLogData]: retrieved charge logs; Example: iex&gt; StarkBank.Charge.Log.get(credentials, [&quot;6307371336859648&quot;, charge])","ref":"StarkBank.Charge.Log.html#get/3","title":"StarkBank.Charge.Log.get/3","type":"function"},{"doc":"Gets the charge log specified by the provided ID; Parameters: credentials [PID]: agent PID returned by StarkBank.Auth.login; charge_log_id [string or StarkBank.Charge.Structs.ChargeLogData]: charge log ID or struct, e.g.: &quot;6743665380687872&quot;; Returns {:ok, charge_log}: charge_log [StarkBank.Charge.Structs.ChargeLogData]: retrieved charge log; Example: iex&gt; StarkBank.Charge.Log.get_by_id(credentials, &quot;6307371336859648&quot;)","ref":"StarkBank.Charge.Log.html#get_by_id/2","title":"StarkBank.Charge.Log.get_by_id/2","type":"function"},{"doc":"","ref":"StarkBank.Charge.Structs.AddressData.html","title":"StarkBank.Charge.Structs.AddressData","type":"module"},{"doc":"Holds charge customer address data Is usually nested in StarkBank.Charge.Structs.Customer Parameters: street_line_1 [string]: e.g.: &quot;Av. Faria Lima, 1844&quot;; street_line_2 [string]: e.g.: &quot;CJ 13&quot;; district [string]: e.g.: &quot;Itaim Bibi&quot;; city [string]: e.g.: &quot;Sao Paulo&quot;; state_code [string]: e.g.: &quot;SP&quot;; zip_code [string]: e.g.: &quot;01500-000&quot;;","ref":"StarkBank.Charge.Structs.AddressData.html#__struct__/0","title":"StarkBank.Charge.Structs.AddressData.__struct__/0","type":"function"},{"doc":"","ref":"StarkBank.Charge.Structs.ChargeCountData.html","title":"StarkBank.Charge.Structs.ChargeCountData","type":"module"},{"doc":"Holds customer charge counters Is usually nested in StarkBank.Charge.Structs.Charge Parameters: overdue [int]: counts the customer overdue charges, e.g.: 3; pending [int]: counts the customer pending charges, e.g.: 2;","ref":"StarkBank.Charge.Structs.ChargeCountData.html#__struct__/0","title":"StarkBank.Charge.Structs.ChargeCountData.__struct__/0","type":"function"},{"doc":"","ref":"StarkBank.Charge.Structs.ChargeData.html","title":"StarkBank.Charge.Structs.ChargeData","type":"module"},{"doc":"Holds data from a single charge Parameters: customer [StarkBank.Charge.Structs.CustomerData]: charge customer data; amount [int]: total charged amount in cents, e.g.: 150000 (= R$1.500,00); id [string]: charge unique ID, e.g.: &quot;5730684534521856&quot;; bar_code [string]: charge bar code, e.g.: &quot;34198777500000500001090000788367307144464000&quot;; line [string]: charge line number, e.g.: &quot;34191.09008 00788.367308 71444.640008 8 77750000050000&quot;; due_date [timestamp as string]: charge due date, e.g.: &quot;2019-01-21T01:59:59.999999+00:00&quot;; issue_date [timestamp as string]: charge issue date, e.g.: &quot;2018-12-29T20:05:33.812908+00:00&quot;; overdue_limit [int]: number of days after due date when the charge will expire, 0&lt;= n &lt;= 59, e.g.: 5; fine [float]: percentage of the charge amount to be charged if paid after due date, e.g.: 2.00 (= 2%); interest [float]: monthly interest, in percentage, charged if paid after due date, e.g.: 1.50 (= 1.5%); discount [float]: defines the discount percentage applicable if charge is paid before discount_date (if discount is defined, discountDate must also be defined) discount_date [date or string (&quot;%Y-%m-%d&quot;)]: defines limit date until when the defined discount will be valid (if discount is defined, discountDate must also be defined) status [string]: charge status, e.g.: created, registered, paid, overdue, canceled, failed; tags [list of strings]: custom tags used when searching charges, e.g.: [&quot;client1&quot;, &quot;cash-in&quot;]; workspace_id [strings]: workspace_id that created the charge, e.g.: &quot;5078376503050240&quot;; descriptions [list of StarkBank.Charge.Structs.ChargeDescriptionData]: list of charge descriptions;","ref":"StarkBank.Charge.Structs.ChargeData.html#__struct__/0","title":"StarkBank.Charge.Structs.ChargeData.__struct__/0","type":"function"},{"doc":"","ref":"StarkBank.Charge.Structs.ChargeDescriptionData.html","title":"StarkBank.Charge.Structs.ChargeDescriptionData","type":"module"},{"doc":"Holds data from a single charge description Is usually nested in StarkBank.Charge.Structs.Charge Parameters: text [string]: text describing the apointed amount, e.g.: &quot;- Taxes&quot;; amount [int]: part of the charge total amount (in cents) that is being described, e.g.: 579;","ref":"StarkBank.Charge.Structs.ChargeDescriptionData.html#__struct__/0","title":"StarkBank.Charge.Structs.ChargeDescriptionData.__struct__/0","type":"function"},{"doc":"","ref":"StarkBank.Charge.Structs.ChargeLogData.html","title":"StarkBank.Charge.Structs.ChargeLogData","type":"module"},{"doc":"Holds data from a single charge log Is usually nested in StarkBank.Charge.Structs.Charge Parameters: id [string]: charge log id, e.g.: 312387192837; event [string]: log event, namely: &quot;register&quot;, &quot;registered&quot;, &quot;overdue&quot;, &quot;updated&quot;, &quot;canceled&quot;, &quot;failed&quot;, &quot;paid&quot; or &quot;bank&quot;; created [timestamp as string]: log creation timestamp, e.g.: &quot;2019-05-21T23:15:50.567533+00:00&quot;; errors [list of strings]: list of errors logs; charge [StarkBank.Charge.Structs.Charge]: charge data;","ref":"StarkBank.Charge.Structs.ChargeLogData.html#__struct__/0","title":"StarkBank.Charge.Structs.ChargeLogData.__struct__/0","type":"function"},{"doc":"","ref":"StarkBank.Charge.Structs.CustomerData.html","title":"StarkBank.Charge.Structs.CustomerData","type":"module"},{"doc":"Holds data from a single customer Can be nested in StarkBank.Charge.Structs.Charge Parameters: name [string]: customer name, e.g.: &quot;Arya Stark&quot;; email [string]: customer email, e.g.: &quot;arya.stark@westeros.com&quot;; tax_id [string]: customer tax ID (CPF, CNPJ), e.g.: &quot;012.345.678-90&quot;; phone [string] customer phone number, e.g.: &quot;(11) 98300-0000&quot;; tags [list of strings]: customer custom tags, e.g.: [&quot;little girl&quot;, &quot;no one&quot;, &quot;valar morghulis&quot;, &quot;Stark&quot;]; address [StarkBank.Charge.Structs.AddressData]: customer adress data;","ref":"StarkBank.Charge.Structs.CustomerData.html#__struct__/0","title":"StarkBank.Charge.Structs.CustomerData.__struct__/0","type":"function"}]